"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var deep_equal_1 = __importDefault(require("deep-equal"));
var queue_1 = __importDefault(require("queue"));
var react_native_1 = require("react-native");
var deviceDimensions_1 = require("./device-dimensions/deviceDimensions");
var keyboardTransitions_1 = __importDefault(require("./keyboardTransitions"));
var KeyboardTransitionTimer_1 = __importDefault(require("./KeyboardTransitionTimer"));
var keyboardEvents = [
    "keyboardDidShow",
    "keyboardDidHide",
    "keyboardDidChangeFrame",
];
var IOSKeyboardEvents = /** @class */ (function () {
    function IOSKeyboardEvents(deviceModel, keyboardEventDebounceTime) {
        var _this = this;
        this.updateKeyboardState = function (nextState) {
            _this.keyboardState = nextState;
            _this.keyboardTransitionTimer.set(function () {
                _this.updateListeners();
            }, _this.keyboardEventDebounceTime);
        };
        this.listeners = {};
        this.keyboardState = "CLOSED";
        this.lastKeyboardEvent = undefined;
        this.lastKeyboardState = "CLOSED";
        this.keyboardTransitionTimer = KeyboardTransitionTimer_1["default"]();
        this.keyboardEventQueue = queue_1["default"]({ concurrency: 1, autostart: true });
        this.keyboardEventDebounceTime = keyboardEventDebounceTime;
        this.deviceModel = deviceModel;
        this.keyboardEventSubscriptions = [];
        this.startKeyboardListeners();
    }
    IOSKeyboardEvents.prototype.addListener = function (listenerName, callback) {
        this.listeners[listenerName] = callback;
    };
    IOSKeyboardEvents.prototype.removeListener = function (listenerName) {
        delete this.listeners[listenerName];
    };
    IOSKeyboardEvents.prototype.close = function () {
        this.keyboardEventSubscriptions.forEach(function (subscription) {
            return subscription.remove();
        });
        this.listeners = {};
        this.keyboardTransitionTimer.reset();
    };
    IOSKeyboardEvents.prototype.getKeyboardState = function () {
        return this.keyboardState;
    };
    IOSKeyboardEvents.prototype.getDeviceModelInformation = function () {
        return this.deviceModel;
    };
    IOSKeyboardEvents.prototype.startKeyboardListeners = function () {
        var _this = this;
        keyboardEvents.forEach(function (eventType) {
            var subscription = react_native_1.Keyboard.addListener(eventType, function (event) {
                _this.onKeyboardEvent(__assign({ eventType: eventType }, event));
            });
            _this.keyboardEventSubscriptions.push(subscription);
        });
    };
    IOSKeyboardEvents.prototype.onKeyboardEvent = function (keyboardEvent) {
        var _this = this;
        var isDuplicateEvent = deep_equal_1["default"](keyboardEvent, this.lastKeyboardEvent);
        if (isDuplicateEvent) {
            return;
        }
        this.lastKeyboardEvent = keyboardEvent;
        this.keyboardEventQueue.push(function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                keyboardTransitions_1["default"]({
                    currentState: this.keyboardState,
                    event: keyboardEvent,
                    deviceOrientation: deviceDimensions_1.getDeviceOrientation(),
                    deviceModel: this.deviceModel,
                    updateKeyboardState: this.updateKeyboardState
                });
                return [2 /*return*/];
            });
        }); });
    };
    IOSKeyboardEvents.prototype.updateListeners = function () {
        var _this = this;
        Object.values(this.listeners).forEach(function (callback) {
            return callback(_this.keyboardState, _this.lastKeyboardState);
        });
        this.lastKeyboardState = this.keyboardState;
    };
    return IOSKeyboardEvents;
}());
exports.IOSKeyboardEvents = IOSKeyboardEvents;
var createIOSKeyboardEvents = function (options) {
    if (options === void 0) { options = {}; }
    var deviceModel = options.deviceModel, _a = options.keyboardEventDebounceTime, keyboardEventDebounceTime = _a === void 0 ? 100 : _a;
    if (deviceModel) {
        return new IOSKeyboardEvents(deviceModel, keyboardEventDebounceTime);
    }
    if (exports.getDevicePlatform() !== "ios") {
        throw new Error("Library only supports iOS.");
    }
    var foundDeviceModel = deviceDimensions_1.getDeviceModel();
    if (!foundDeviceModel) {
        throw new Error("Unable to interpret device model from given dimensions.");
    }
    return new IOSKeyboardEvents(foundDeviceModel, keyboardEventDebounceTime);
};
exports.getDevicePlatform = function () { return react_native_1.Platform.OS; };
exports["default"] = createIOSKeyboardEvents;
