export interface IDeviceModel {
    model: string;
    isTablet: boolean;
    screenDimensions: Set<number>;
    keyboardDimensions: KeyboardDimensions;
}
export declare type DeviceOrientation = "landscape" | "portrait";
export declare type KeyboardDimensions = {
    [o in DeviceOrientation]: {
        docked: number;
        split?: number;
        minimized?: number;
    };
};
export declare const devices: IDeviceModel[];
export declare const getDeviceOrientation: () => DeviceOrientation;
export declare const getDeviceModel: () => IDeviceModel | undefined;
