"use strict";
exports.__esModule = true;
var minimizedKeyboardHandler = function (args) {
    var event = args.event, updateKeyboardState = args.updateKeyboardState, deviceOrientation = args.deviceOrientation, deviceModel = args.deviceModel;
    var _a = deviceModel.keyboardDimensions[deviceOrientation], split = _a.split, docked = _a.docked;
    if (event.eventType === "keyboardDidHide" &&
        event.endCoordinates.height === 0) {
        updateKeyboardState("CLOSED");
        return;
    }
    if (event.eventType === "keyboardDidChangeFrame" &&
        event.endCoordinates.height === docked) {
        updateKeyboardState("UNDOCKED");
        return;
    }
    if (event.eventType === "keyboardDidChangeFrame" &&
        event.endCoordinates.height === split) {
        updateKeyboardState("SPLIT");
        return;
    }
};
exports["default"] = minimizedKeyboardHandler;
