"use strict";
exports.__esModule = true;
var undockedKeyboardHandler = function (args) {
    var event = args.event, updateKeyboardState = args.updateKeyboardState, deviceModel = args.deviceModel, deviceOrientation = args.deviceOrientation;
    var _a = deviceModel.keyboardDimensions[deviceOrientation], split = _a.split, docked = _a.docked, minimized = _a.minimized;
    if (event.eventType === "keyboardDidShow" &&
        event.endCoordinates.height === docked) {
        updateKeyboardState("DOCKED");
        return;
    }
    if (event.eventType === "keyboardDidShow" &&
        event.endCoordinates.height === minimized) {
        updateKeyboardState("MINIMIZED");
        return;
    }
    if (event.eventType === "keyboardDidChangeFrame" &&
        event.endCoordinates.height === split) {
        updateKeyboardState("SPLIT");
        return;
    }
    if (event.eventType === "keyboardDidChangeFrame" &&
        event.endCoordinates.height === 0) {
        updateKeyboardState("CLOSED");
        return;
    }
};
exports["default"] = undockedKeyboardHandler;
