"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var closedKbTransitions_1 = __importDefault(require("./keyboard-transitions/closedKbTransitions"));
var dockedKbTransitions_1 = __importDefault(require("./keyboard-transitions/dockedKbTransitions"));
var minimizedKbTransitions_1 = __importDefault(require("./keyboard-transitions/minimizedKbTransitions"));
var splitKbTransitions_1 = __importDefault(require("./keyboard-transitions/splitKbTransitions"));
var undockedKbTransitions_1 = __importDefault(require("./keyboard-transitions/undockedKbTransitions"));
var doKeyboardTransitions = function (args) {
    var actions = {
        CLOSED: closedKbTransitions_1["default"],
        DOCKED: dockedKbTransitions_1["default"],
        UNDOCKED: undockedKbTransitions_1["default"],
        MINIMIZED: minimizedKbTransitions_1["default"],
        SPLIT: splitKbTransitions_1["default"]
    };
    var action = actions[args.currentState];
    if (action) {
        action(args);
    }
};
exports["default"] = doKeyboardTransitions;
